Sale-CardToken-L3

API Explorer
https://payment.ipospays.tech/api/v3/iposTransact
POST

For Level 3 / VISA CEDP Transactions

As part of updated CEDP (Commercial Enhanced Data Program), Level 3 data is now required for commercial and corporate card transactions to qualify for optimized interchange rates.

To support this, please ensure you are submitting accurate, complete, and properly formatted Level 3 data in your requests. Poor data quality (e.g., missing fields, incorrect values, or placeholder data) may lead to downgraded interchange qualification or rejections.

This includes fields such as item descriptions, quantities, unit costs, tax amounts, and other line-item details. The cleaner and more complete the data, the better the chances of qualifying for enhanced rates.

Sale Transaction

A Level 3 / VISA CEDP sale transaction enables you to include detailed line-item information in the sale requests. By providing this enhanced transaction data, you can qualify for better interchange rates offered by the card networks.

You can send Level 3 / VISA CEDP line items in a sale transaction using cardToken and paymentTokenId. Sample request for both methods are provided below.

Header Parameters

token*string

Authentication token generated using the API Key and Secret Key. Required for all API requests.

Request Body

application/json

Response Body

application/json

application/json

curl -X POST "https://example.com" \  -H "token: string" \  -H "Content-Type: application/json" \  -d '{    "merchantAuthentication": {      "merchantId": "962923571839",      "transactionReferenceId": "7687678687457er3444d4r4e3983"    },    "transactionRequest": {      "transactionType": 1,      "amount": "233",      "cardToken": "4FDE6038029EAD4445C8C3396E511B7628A71B677407F8D5",      "applySteamSettingTipFeeTax": true    },    "preferences": {      "eReceipt": true,      "customerName": "Shankar",      "customerEmail": "sthanigaivel@denovsystem.com",      "customerMobile": "+918072892144"    },    "L3Data": {      "Header": {        "TaxAmount": 1.23,        "LocalTaxFlag": 1,        "NationalTaxAmount": 2.23,        "DestZipCode": "23432",        "SummaryCommodityCode": "",        "TaxRateApplied": 6,        "TotalDiscountAmount": 1.25,        "PoNumber": "10123456",        "FreightAmount": 10,        "DutyAmount": 12,        "ShipFromZipCode": "23234",        "DestCountryCode": "840",        "MerchantTaxId": "457896",        "LineItemCount": 1,        "AltTaxAmount": 1,        "PurchaseIdentifier": "",        "PurchaseIdFormatCode": "1",        "OrderDate": "2025-11-21",        "AltTaxIndicator": true      },      "items": [        {          "CommodityCode": "12345678901234",          "Description": "Milk is a diary product",          "ProductCode": "1234567890",          "Quantity": 1,          "UnitOfMeasure": "123456789ITM123",          "UnitCost": 1,          "TaxAmount": 3,          "TaxRate": "",          "DiscountAmount": 1,          "DiscountRate": 23443678099,          "DiscountIndicator": true,          "NetGrossIndicator": false,          "DebitCreditIndicator": "",          "ExtLineAmount": "123456",          "AltTaxID": 101,          "TaxTypeApplied": "ccc123",          "NationalTaxAmount": 2.25,          "NationalTaxRate": 3,          "TaxIndicator": 3        }      ]    }  }'
{
  "iposhpresponse": {
    "consumerId": "55TSKB6V3WUG",
    "responseCode": "400",
    "responseMessage": "Failed",
    "errResponseCode": "05",
    "errResponseMessage": "PLS TRY FULL PAN",
    "transactionReferenceId": "7687678687457er3444d4r4e39851",
    "transactionType": "1",
    "transactionId": "40690497613257183920251126072756",
    "amount": "233",
    "totalAmount": "403",
    "customFee": "100",
    "localTax": "47",
    "stateTax": "23",
    "l2l3ValidationError": null,
    "l2l3Flag": "N"
  }
}
{
  "errors": [
    {
      "field": "cardNumber",
      "message": "Invalid card number format."
    }
  ]
}